.686
.model flat,stdcall
option casemap:none

.const

ADLER32_BASE equ 65521 ; largest prime smaller than 65536
ADLER32_NMAX equ 5552 ; largest n such that 255n(n+1)/2 + (n+1)(BASE-1) <= 2^32-1

.code

align dword
Adler32 proc uses edi esi ebx lpBuffer:DWORD, dwBufLen:DWORD, dwAdler:DWORD
	movzx eax,word ptr dwAdler[0]
	movzx ebx,word ptr dwAdler[2]
	mov ecx,dwBufLen
	mov esi,lpBuffer
	test ecx,ecx
	jz @F
	.repeat
		mov edi,ADLER32_NMAX
		cmp ecx,edi
		cmovc edi,ecx
        sub ecx,edi
		.repeat
			movzx edx,byte ptr [esi]
			add eax,edx
			inc esi
			add ebx,eax
			dec edi
		.until ZERO?
        mov edi,ADLER32_BASE
        xor edx,edx
        div edi
        push edx
        mov eax,ebx
        xor edx,edx
        div edi
        mov ebx,edx
		test ecx,ecx
        pop eax
	.until ZERO?
@@:	shl ebx,16
	add eax,ebx
	ret
Adler32 endp

end
