; data   = 8 bytes (64-bit)
; keylen = 16 bytes (128-bit)
; rounds = 32

.686
.model flat,stdcall
option casemap:none

TEAInit	proto :DWORD
TEAEncrypt	proto :DWORD,:DWORD
TEADecrypt	proto :DWORD,:DWORD

TEA_ROUNDS equ 32
TEA_DELTA equ 9E3779B9h


.data?
TEA_KEY dd 4 dup(?)

.code

align 8
TEAInit proc pKey:DWORD
	mov eax,pKey
	mov ecx,[eax+0*4]
	mov edx,[eax+1*4]
	bswap ecx
	bswap edx
	mov [TEA_KEY+0*4],ecx
	mov [TEA_KEY+1*4],edx
	mov ecx,[eax+2*4]
	mov edx,[eax+3*4]
	bswap ecx
	bswap edx
	mov [TEA_KEY+2*4],ecx
	mov [TEA_KEY+3*4],edx
	ret
TEAInit endp

TEARND1 macro _i,y,z,enc
	mov ecx,z
	shl ecx,4
	mov edi,z
	lea esi,[z+(TEA_DELTA*_i)]
	add ecx,ebp
	shr edi,5
	xor ecx,esi
	add edi,ebx
	xor ecx,edi
	if enc
	add y,ecx
	else
	sub y,ecx
	endif
endm

TEARND2 macro _i,y,z,enc
	mov ecx,z
	shl ecx,4
	mov edi,z
	lea esi,[z+(TEA_DELTA*_i)]
	add ecx,[TEA_KEY+2*4]
	shr edi,5
	xor ecx,esi
	add edi,[TEA_KEY+3*4]
	xor ecx,edi
	if enc
	add y,ecx
	else
	sub y,ecx
	endif
endm

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 8
TEAEncrypt proc pBlockIn:DWORD,pBlockOut:DWORD
	push ebp
	push edi
	push esi
	push ebx
	mov esi,[esp+1*4][4*4];pBlockIn
	mov ebp,[TEA_KEY+0*4]
	mov ebx,[TEA_KEY+1*4]
	mov eax,[esi+0*4];y
	mov edx,[esi+1*4];z
	bswap eax
	bswap edx
	xi = 1
	repeat TEA_ROUNDS
		TEARND1 xi,eax,edx,1
		TEARND2 xi,edx,eax,1
		xi = xi + 1
	endm
	mov esi,[esp+2*4][4*4];pBlockOut
	bswap eax
	bswap edx
	mov [esi+0*4],eax
	mov [esi+1*4],edx
	pop ebx
	pop esi
	pop edi
	pop ebp
	ret 2*4
TEAEncrypt endp

align 8
TEADecrypt proc pBlockIn:DWORD,pBlockOut:DWORD
	push ebp
	push edi
	push esi
	push ebx
	mov esi,[esp+1*4][4*4];pBlockIn
	mov ebp,[TEA_KEY+0*4]
	mov ebx,[TEA_KEY+1*4]
	mov eax,[esi+0*4]
	mov edx,[esi+1*4]
	bswap eax
	bswap edx
	xi = 32
	repeat TEA_ROUNDS
		TEARND2 xi,edx,eax,0
		TEARND1 xi,eax,edx,0
		xi = xi - 1
	endm
	mov esi,[esp+2*4][4*4];pBlockOut
	bswap eax
	bswap edx
	mov [esi+0*4],eax
	mov [esi+1*4],edx
	pop ebx
	pop esi
	pop edi
	pop ebp
	ret 2*4
TEADecrypt endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

end
